import e, { createContext as K, useContext as Q, useMemo as M, useCallback as V, useRef as D, useEffect as L, useState as $ } from "react";
import { get as X, set as J, clone as W } from "radash";
import { usePointerDrag as B } from "react-use-pointer-drag";
import { SketchPicker as Z } from "react-color";
import _ from "filesize";
const A = K(void 0);
function b(a, l, s) {
  const n = Q(A), r = M(() => (n == null ? void 0 : n.getValue(a)) ?? l, [n, a, l]), c = V((t) => {
    a && n && n.setValue(a, t), s == null || s(t);
  }, [a, n, s]);
  return [r, c];
}
const ce = ({ values: a, updateValues: l, onChange: s, onChangeValue: n, className: r, children: c }) => {
  const t = V((o) => o ? X(a, o) : void 0, [a]), i = V((o, m) => {
    n == null || n(o, m);
    const v = J(W(a), o, m);
    l == null || l(v), s == null || s(v);
  }, [a, l, s, n]), u = M(() => ({ values: a, getValue: t, setValue: i }), [a, t, i]);
  return e.createElement(
    A.Provider,
    { value: u },
    e.createElement("div", { className: "react-var-ui " + (r ?? "") }, c)
  );
}, C = ({ label: a, children: l, className: s, disabled: n, readOnly: r, column: c = !1 }) => e.createElement(
  "div",
  { className: "react-var-ui-label " + (a ? "react-var-ui-label-has-label " : "react-var-ui-label-no-label ") + (n ? "react-var-ui-disabled " : "") + (r ? "react-var-ui-read-only " : "") + (c ? "react-var-ui-label-column " : "") + (s ?? "") },
  !!a && e.createElement("span", null, a),
  l
), U = Math.PI * 2;
function z(a) {
  return (U + a % U) % U;
}
const ne = ({ label: a, path: l, value: s, onChange: n, disabled: r, readOnly: c, defaultValue: t = 0, className: i }) => {
  const u = D(null), [o, m] = b(l, s, n), v = M(() => Math.round(z(o) * (180 / Math.PI)), [o]), { dragProps: g } = B({
    onMove: ({ x: d, y: E }) => {
      if (!u.current)
        return;
      const f = u.current.getBoundingClientRect(), N = f.left + f.width / 2, h = f.top + f.height / 2;
      m(z(Math.atan2(E - h, d - N) + Math.PI / 2));
    }
  });
  return L(() => {
    var d;
    (d = u.current) == null || d.addEventListener("wheel", (E) => E.preventDefault());
  }, []), e.createElement(
    C,
    { label: a, disabled: r, readOnly: c, className: i, column: !0 },
    e.createElement(
      "span",
      { className: "react-var-ui-angle-value" },
      v,
      "°"
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-angle" },
      e.createElement("div", { className: "react-var-ui-angle-control react-var-ui-interactive", ref: u, style: { transform: `rotate(${v}deg)` }, onDoubleClick: () => typeof t < "u" && m(t), onWheel: (d) => {
        m(z(o + 0.5 * (d.deltaY < 0 ? -1 : 1)));
      }, title: "Angle", ...g() })
    )
  );
}, le = ({ path: a, value: l, onChange: s, disabled: n, className: r, children: c }) => {
  const [t, i] = b(a, l, s);
  return e.createElement("div", { className: "react-var-ui-array " + (n ? "react-var-ui-disabled " : "") + (r ?? "") }, t == null ? void 0 : t.map((u, o, m) => e.createElement(A.Provider, { value: {
    values: u,
    getValue: (v) => v ? X(u, v) : void 0,
    setValue: (v, g) => {
      const d = [...t];
      d[o] = J(W(u), v, g), i(d);
    }
  }, key: o }, typeof c == "function" ? c(u, o, m) : c)));
}, oe = ({ label: a, onClick: l, buttonLabel: s, disabled: n, className: r }) => e.createElement(
  C,
  { label: a, disabled: n, className: r },
  e.createElement(
    "span",
    { className: "react-var-ui-button" },
    e.createElement("button", { onClick: () => l == null ? void 0 : l(), disabled: n }, s)
  )
), se = ({ label: a, path: l, value: s, onChange: n, alpha: r, disabled: c, readOnly: t, className: i }) => {
  const [u, o] = b(l, s, n), [m, v] = $(!1), g = V(() => v((E) => !E), [v]), d = V(() => v(!1), [v]);
  return e.createElement(
    C,
    { label: a, disabled: c, readOnly: t, className: i },
    e.createElement(
      "span",
      null,
      e.createElement("span", { className: "react-var-ui-color-value" }, u),
      e.createElement(
        "div",
        { className: "react-var-ui-color react-var-ui-interactive" },
        e.createElement(
          "div",
          { className: "react-var-ui-color-swatch", onClick: g },
          e.createElement("div", { className: "react-var-ui-color-color", title: "Color preview", style: { background: u } })
        ),
        m ? e.createElement(
          "div",
          { className: "react-var-ui-color-popover" },
          e.createElement("div", { className: "react-var-ui-color-cover", onClick: d }),
          e.createElement(Z, { color: u, onChange: (E) => {
            const p = E.hex === "transparent" ? "#000000" : E.hex;
            if (r) {
              let f = Math.round((E.rgb.a ?? 1) * 255).toString(16);
              f.length === 1 && (f = "0" + f), o(p + f);
            } else
              o(p);
          }, disableAlpha: !r })
        ) : null
      )
    )
  );
}, ie = ({ label: a, path: l, value: s, disabled: n, readOnly: r, className: c }) => {
  const [t] = b(l, s);
  return e.createElement(
    C,
    { label: a, disabled: n, readOnly: r, className: c },
    e.createElement("span", null, t)
  );
}, T = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { d: "M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z" }),
  e.createElement("path", { d: "M7.646 1.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 2.707V11.5a.5.5 0 0 1-1 0V2.707L5.354 4.854a.5.5 0 1 1-.708-.708l3-3z" })
), ue = ({ label: a, path: l, value: s, onChange: n, disabled: r, readOnly: c, className: t, accept: i, displayMetadata: u = !0 }) => {
  const [o, m] = b(l, s, n), v = V((g) => {
    var E;
    if (!((E = g.target.files) != null && E.length))
      return;
    const d = g.target.files[0];
    m(d);
  }, [m]);
  return e.createElement(
    C,
    { label: a, disabled: r, readOnly: c, className: t },
    e.createElement("span", { className: "react-var-ui-file-value" }, o == null ? void 0 : o.name),
    e.createElement(
      "div",
      { className: "react-var-ui-file react-var-ui-interactive" },
      u && !!o && e.createElement(
        "div",
        { className: "react-var-ui-file-metadata" },
        e.createElement(
          "div",
          null,
          "Size: ",
          _(o.size)
        ),
        e.createElement(
          "div",
          null,
          "Type: ",
          o.type || "unknown"
        )
      ),
      e.createElement(T, null),
      e.createElement("input", { type: "file", accept: i, onChange: v, title: "File upload" })
    )
  );
}, ve = ({ label: a, path: l, value: s, onChange: n, disabled: r, readOnly: c, className: t }) => {
  const [i, u] = b(l, s, n), o = V((m) => {
    var d;
    if (!((d = m.target.files) != null && d.length))
      return;
    const v = m.target.files[0], g = URL.createObjectURL(v);
    u(g);
  }, [u]);
  return e.createElement(
    C,
    { label: a, disabled: r, readOnly: c, className: t, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-image react-var-ui-interactive" },
      e.createElement("div", { className: "react-var-ui-image-background", style: {
        backgroundImage: i ? `url('${i}')` : void 0
      }, title: "Image preview" }),
      e.createElement(T, null),
      e.createElement("input", { type: "file", accept: "image/*", onChange: o, title: "Image upload" })
    )
  );
}, me = ({ label: a, path: l, value: s, onChange: n, disabled: r, readOnly: c, className: t, acceptImage: i, acceptAudio: u, acceptVideo: o }) => {
  const [m, v] = b(l, s, n), [g, d] = $(), E = M(() => {
    let h = "";
    return i && (h += "image/*,"), u && (h += "audio/*,"), o && (h += "video/*,"), h.endsWith(",") && (h = h.slice(0, -1)), h || (h = "image/*,audio/*,video/*"), h;
  }, [i, u, o]), p = V((h) => {
    var I;
    if (!((I = h.target.files) != null && I.length))
      return;
    const w = h.target.files[0], k = URL.createObjectURL(w);
    v(k);
  }, [v, d]), f = V(async (h) => {
    var k, I, S;
    if (!h) {
      d(void 0);
      return;
    }
    const w = await fetch(h);
    d((S = (I = (k = w == null ? void 0 : w.headers) == null ? void 0 : k.get("Content-Type")) == null ? void 0 : I.split("/")) == null ? void 0 : S[0]);
  }, [d]);
  L(() => {
    f(m);
  }, [m]);
  let N = e.createElement("div", { className: "react-var-ui-media-metadata" }, m ? "Unsupported file type." : "");
  switch (g) {
    case "image":
      N = e.createElement("div", { className: "react-var-ui-media-background", style: {
        backgroundImage: `url('${m}')`
      }, title: "Media preview" });
      break;
    case "video":
      N = e.createElement("video", { className: "react-var-ui-media-background", muted: !0, loop: !0, autoPlay: !0, src: m, title: "Media preview" });
      break;
    case "audio":
      N = e.createElement("audio", { className: "react-var-ui-media-audio", loop: !0, controls: !0, src: m, title: "Media preview" });
      break;
  }
  return e.createElement(
    C,
    { label: a, disabled: r, readOnly: c, className: t, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-media react-var-ui-interactive" },
      N,
      e.createElement(T, null),
      e.createElement("input", { type: "file", accept: E, onChange: p, title: "Media upload" })
    )
  );
};
function P(a, l, s, n, r) {
  var t;
  isFinite(a) || (a = l ?? 0);
  let c = 2;
  return typeof n == "number" && (c = ((t = n.toString().split(".")[1]) == null ? void 0 : t.length) || 0, c > 20 && (c = 20), a = Math.round(a / n) * n), typeof l == "number" && (a = Math.max(l, a)), typeof s == "number" && (a = Math.min(s, a)), r ? Math.round(a) : parseFloat(a.toFixed(c));
}
const j = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z" })
), H = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M7.646 4.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1-.708.708L8 5.707l-5.646 5.647a.5.5 0 0 1-.708-.708l6-6z" })
), de = ({ label: a, path: l, value: s, onChange: n, min: r, max: c, step: t = 1, integer: i, showButtons: u, disabled: o, readOnly: m, className: v }) => {
  const [g, d] = b(l, s, n), E = M(() => P(g, r, c, t, !!i), [g, r, c, t, i]), p = V(() => d(P(g + (t ?? 1), r, c, t, !!i)), [g, d, i, r, c, t]), f = V(() => d(P(g - (t ?? 1), r, c, t, !!i)), [g, d, i, r, c, t]);
  return e.createElement(
    C,
    { label: a, disabled: o, readOnly: m, className: v },
    e.createElement(
      "div",
      { className: "react-var-ui-number" },
      e.createElement("input", { className: "react-var-ui-number-input", type: "number", min: r, max: c, step: t, value: E.toString(), disabled: o, readOnly: m, onChange: (N) => d(P(parseFloat(N.target.value), r, c, t, !!i)) }),
      u && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: p, disabled: o || m },
          e.createElement(H, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: f, disabled: o || m },
          e.createElement(j, null)
        )
      )
    )
  );
}, Ee = ({ label: a, path: l, value: s, onChange: n, options: r, disabled: c, readOnly: t, className: i }) => {
  const [u, o] = b(l, s, n), m = M(() => JSON.stringify(u), [u]);
  return e.createElement(
    C,
    { label: a, disabled: c, readOnly: t, className: i },
    e.createElement(
      "div",
      { className: "react-var-ui-select" },
      e.createElement("select", { onChange: (v) => o(JSON.parse(v.target.value)), value: m, title: "Select options", disabled: c || t }, r.map((v) => {
        const g = JSON.stringify(v.value ?? v.key);
        return e.createElement("option", { key: v.key, value: g }, v.label);
      }))
    )
  );
}, ge = ({ label: a, path: l, value: s, onChange: n, min: r, max: c, step: t, integer: i, defaultValue: u, showInput: o, showButtons: m, disabled: v, readOnly: g, className: d }) => {
  const E = D(null), [p, f] = b(l, s, n), N = M(() => P(p, r, c, t, !!i), [p, r, c, t, i]), h = M(() => (N - r) / (c - r) * 100, [N, r, c]), w = V((y) => {
    if (!E.current)
      return;
    const R = E.current.getBoundingClientRect(), q = (y - R.left) / R.width, G = P(r + (c - r) * q, r, c, t, !!i);
    f(G);
  }, [f, i, r, c, t]), k = V(() => f(P(p + t, r, c, t, !!i)), [p, f, i, r, c, t]), I = V(() => f(P(p - t, r, c, t, !!i)), [p, f, i, r, c, t]), { dragProps: S } = B({
    onMove: ({ x: y }) => w(y)
  });
  return L(() => {
    var y;
    (y = E.current) == null || y.addEventListener("wheel", (F) => F.preventDefault());
  }, []), e.createElement(
    C,
    { label: a, disabled: v, readOnly: g, className: d },
    e.createElement(
      "div",
      { className: "react-var-ui-slider" },
      e.createElement(
        "div",
        { className: "react-var-ui-slider-track react-var-ui-interactive", ref: E, onClick: (y) => w(y.clientX), onDoubleClick: () => typeof u < "u" && f(u), onWheel: (y) => {
          y.deltaY < 0 ? k() : I();
        }, title: "Slider", ...S() },
        e.createElement("div", { className: "react-var-ui-slider-content", style: { width: h + "%" } })
      ),
      o ? e.createElement("input", { className: "react-var-ui-slider-input", type: "number", min: r, max: c, step: t, value: N, disabled: v, readOnly: g, onChange: (y) => f(P(parseFloat(y.target.value), r, c, t, !!i)) }) : e.createElement("span", null, N.toString()),
      m && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: k, disabled: v || g },
          e.createElement(H, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: I, disabled: v || g },
          e.createElement(j, null)
        )
      )
    )
  );
}, fe = ({ label: a, path: l, value: s, onChange: n, maxLength: r, multiline: c, autoexpand: t, disabled: i, readOnly: u, className: o }) => {
  const [m, v] = b(l, s, n), g = (E) => {
    const p = E.currentTarget;
    p.style.height = "0", p.style.height = `${p.scrollHeight}px`;
  }, d = M(() => t ? { overflow: "hidden", resize: "none" } : void 0, [t]);
  return e.createElement(C, { label: a, disabled: i, readOnly: u, className: o, column: c }, c ? e.createElement("textarea", { className: "react-var-ui-string-multiline", value: m, onChange: (E) => v(E.target.value), onInput: t ? g : void 0, style: d, disabled: i, readOnly: u }) : e.createElement(
    "span",
    { className: "react-var-ui-string" },
    e.createElement("input", { type: "text", maxLength: r, value: m, onChange: (E) => v(E.target.value), disabled: i, readOnly: u })
  ));
}, pe = ({ label: a, path: l, value: s, onChange: n, disabled: r, readOnly: c, className: t }) => {
  const [i, u] = b(l, s, n);
  return e.createElement(
    C,
    { label: a, disabled: r, readOnly: c, className: t },
    e.createElement(
      "span",
      null,
      e.createElement(
        "label",
        { className: "react-var-ui-toggle", title: "Toggle" },
        e.createElement("input", { type: "checkbox", checked: i, onChange: (o) => u(o.target.checked), disabled: r, readOnly: c }),
        e.createElement("span", { className: "react-var-ui-toggle-helper" })
      )
    )
  );
};
function Y(a, l, s, n) {
  var c;
  const r = [0, 0];
  if (!a || !Array.isArray(a) || a.length < 2)
    return r;
  for (let t = 0; t < n.length; t++) {
    const i = ((c = n[t].toString().split(".")[1]) == null ? void 0 : c.length) || 0;
    r[t] = Math.round(a[t] / n[t]) * n[t], r[t] = Math.max(l[t], r[t]), r[t] = Math.min(s[t], r[t]), r[t] = parseFloat(r[t].toFixed(i));
  }
  return r;
}
function x(a, l, s) {
  if (!a)
    return [50, 50];
  const n = [0, 0];
  for (let r = 0; r < a.length; r++)
    n[r] = (a[r] - l[r]) / (s[r] - l[r]) * 100;
  return n;
}
const he = ({ label: a, path: l, value: s, onChange: n, disabled: r, readOnly: c, className: t, defaultValue: i = [0, 0], min: u = [-1, -1], max: o = [1, 1], step: m = [0.01, 0.01] }) => {
  const v = D(null), [g, d] = b(l, s, n), E = M(() => Y(g, u, o, m), [g, u, o, m]), p = M(() => x(E, u, o), [E, u, o]), f = V((w, k) => {
    if (!v.current)
      return;
    const S = v.current.getBoundingClientRect(), y = (w - S.left) / S.width, F = (k - S.top) / S.height, R = Y([
      u[0] + (o[0] - u[0]) * y,
      u[1] + (o[1] - u[1]) * F
    ], u, o, m);
    d(R);
  }, [d, u, o, m]), { dragProps: N } = B({
    onMove: ({ x: w, y: k }) => f(w, k)
  }), h = V(() => {
    typeof i < "u" && d(i);
  }, [i, d]);
  return e.createElement(
    C,
    { label: a, disabled: r, readOnly: c, className: t, column: !0 },
    e.createElement(
      "span",
      { className: "react-var-ui-xy-value" },
      E[0],
      ", ",
      E[1]
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-xy react-var-ui-interactive" },
      e.createElement(
        "div",
        { className: "react-var-ui-xy-space", ref: v, onClick: (w) => f(w.clientX, w.clientY), onDoubleClick: h, ...N() },
        e.createElement("div", { className: "react-var-ui-xy-control", style: { top: p[1] + "%", left: p[0] + "%" } })
      )
    )
  );
}, Ve = ({ label: a, className: l, children: s }) => e.createElement(
  "div",
  { className: "react-var-ui-category " + (l ?? "") },
  e.createElement("div", { className: "react-var-ui-category-title" }, a),
  !!s && e.createElement("div", null, s)
);
export {
  ne as VarAngle,
  le as VarArray,
  C as VarBase,
  oe as VarButton,
  Ve as VarCategory,
  se as VarColor,
  ie as VarDisplay,
  ue as VarFile,
  ve as VarImage,
  me as VarMedia,
  de as VarNumber,
  Ee as VarSelect,
  ge as VarSlider,
  fe as VarString,
  pe as VarToggle,
  ce as VarUI,
  he as VarXY,
  b as useVarUIValue
};
